/**
 * 
 */
package com.wieseke.cptk.common.action;

import org.eclipse.jface.action.Action;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.ISelectionListener;
import org.eclipse.ui.IWorkbenchPart;

import com.wieseke.cptk.common.selection.CophylogenyViewerSelection;
import com.wieseke.cptk.common.viewer.CophylogenyViewer;

/**
 * @author Nicolas Wieseke
 * 
 */
public abstract class CommonAction extends Action implements ISelectionListener {

	/**
	 * the cophylogeny viewer
	 */
	protected CophylogenyViewer viewer;

	/**
	 * the workbench page
	 */
	protected IWorkbenchPart part;

	/**
	 * constructor
	 * 
	 * @param text
	 */
	public CommonAction(String text) {
		super(text);
		setEnabled(false);
	}

	/**
	 * constructor
	 * 
	 * @param text
	 * @param style
	 */
	public CommonAction(String text, int style) {
		super(text, style);
		setEnabled(false);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @seeorg.eclipse.ui.ISelectionListener#selectionChanged(org.eclipse.ui.
	 * IWorkbenchPart, org.eclipse.jface.viewers.ISelection)
	 */
	
	public void selectionChanged(IWorkbenchPart part, ISelection selection) {
		this.part = part;
		if (!selection.isEmpty()
				&& selection instanceof CophylogenyViewerSelection) {
			this.viewer = ((CophylogenyViewerSelection) selection)
					.getCophylogenyViewer();
		}
	}

	/**
	 * @return the shell
	 */
	protected Shell getShell() {
		if (this.part != null && this.part.getSite() != null) {
			return this.part.getSite().getShell();
		}
		return null;
	}
}
