/**
 * 
 */
package com.wieseke.cptk.common.constants;

import java.util.LinkedHashMap;
import java.util.Map;

import com.wieseke.cptk.common.util.Tupel;

/**
 * @author Nicolas Wieseke
 * 
 */
public class OptionsConstants {

	/**
	 * @return a map with the option ids with the corresponding selections
	 */
	public static Map<String, Tupel<String, Map<String, String>>> getOptions() {
		Map<String, Tupel<String, Map<String, String>>> options = new LinkedHashMap<String, Tupel<String, Map<String, String>>>();

		Map<String, String> option = new LinkedHashMap<String, String>();
		option.put(HOSTSWITCH_0_ID, HOSTSWITCH_0_TEXT);
		option.put(HOSTSWITCH_1_ID, HOSTSWITCH_1_TEXT);
		option.put(HOSTSWITCH_2_ID, HOSTSWITCH_2_TEXT);
		Tupel<String, Map<String, String>> entry = new Tupel<String, Map<String, String>>(
				HOSTSWITCH_TEXT, option);
		options.put(HOSTSWITCH_ID, entry);

		option = new LinkedHashMap<String, String>();
		option.put(SORTING_0_ID, SORTING_0_TEXT);
		option.put(SORTING_1_ID, SORTING_1_TEXT);
		option.put(SORTING_2_ID, SORTING_2_TEXT);
		entry = new Tupel<String, Map<String, String>>(SORTING_TEXT, option);
		options.put(SORTING_ID, entry);

		option = new LinkedHashMap<String, String>();
		option.put(DUPLICATION_0_ID, DUPLICATION_0_TEXT);
		option.put(DUPLICATION_1_ID, DUPLICATION_1_TEXT);
		entry = new Tupel<String, Map<String, String>>(DUPLICATION_TEXT, option);
		options.put(DUPLICATION_ID, entry);

		option = new LinkedHashMap<String, String>();
		option.put(TAKEOFF_0_ID, TAKEOFF_0_TEXT);
		option.put(TAKEOFF_1_ID, TAKEOFF_1_TEXT);
		entry = new Tupel<String, Map<String, String>>(TAKEOFF_TEXT, option);
		options.put(TAKEOFF_ID, entry);

		option = new LinkedHashMap<String, String>();
		option.put(FULL_HOSTSWITCH_0_ID, FULL_HOSTSWITCH_0_TEXT);
		option.put(FULL_HOSTSWITCH_1_ID, FULL_HOSTSWITCH_1_TEXT);
		entry = new Tupel<String, Map<String, String>>(FULL_HOSTSWITCH_TEXT,
				option);
		options.put(FULL_HOSTSWITCH_ID, entry);

		option = new LinkedHashMap<String, String>();
		option.put(RANK_0_ID, RANK_0_TEXT);
		option.put(RANK_1_ID, RANK_1_TEXT);
		entry = new Tupel<String, Map<String, String>>(RANK_TEXT, option);
		options.put(RANK_ID, entry);

		// option = new LinkedHashMap<String, String>();
		// option.put(PROBABILITY_COSTS_0_ID, PROBABILITY_COSTS_0_TEXT);
		// option.put(PROBABILITY_COSTS_1_ID, PROBABILITY_COSTS_1_TEXT);
		// entry = new OptionsEntry(PROBABILITY_COSTS_TEXT, option);
		// options.put(PROBABILITY_COSTS_ID, entry);

		option = new LinkedHashMap<String, String>();
		option.put(LEAF_SPECIACION_COST_0_ID, LEAF_SPECIACION_COST_0_TEXT);
		option.put(LEAF_SPECIACION_COST_1_ID, LEAF_SPECIACION_COST_1_TEXT);
		entry = new Tupel<String, Map<String, String>>(
				LEAF_SPECIACION_COST_TEXT, option);
		options.put(LEAF_SPECIACION_COST_ID, entry);

		option = new LinkedHashMap<String, String>();
		option.put(ROOT_MAPPING_0_ID, ROOT_MAPPING_0_TEXT);
		option.put(ROOT_MAPPING_1_ID, ROOT_MAPPING_1_TEXT);
		entry = new Tupel<String, Map<String, String>>(ROOT_MAPPING_TEXT,
				option);
		options.put(ROOT_MAPPING_ID, entry);

		option = new LinkedHashMap<String, String>();
		option.put(CHECK_CHRONOLOGY_0_ID, CHECK_CHRONOLOGY_0_TEXT);
		option.put(CHECK_CHRONOLOGY_1_ID, CHECK_CHRONOLOGY_1_TEXT);
		entry = new Tupel<String, Map<String, String>>(CHECK_CHRONOLOGY_TEXT,
				option);
		options.put(CHECK_CHRONOLOGY_ID, entry);

		option = new LinkedHashMap<String, String>();
		option.put(AUTOMATIC_COSTS_0_ID, AUTOMATIC_COSTS_0_TEXT);
		option.put(AUTOMATIC_COSTS_1_ID, AUTOMATIC_COSTS_1_TEXT);
		entry = new Tupel<String, Map<String, String>>(AUTOMATIC_COSTS_TEXT,
				option);
		options.put(AUTOMATIC_COSTS_ID, entry);

		option = new LinkedHashMap<String, String>();
		option.put(AUTOMATIC_METHOD_0_ID, AUTOMATIC_METHOD_0_TEXT);
		option.put(AUTOMATIC_METHOD_1_ID, AUTOMATIC_METHOD_1_TEXT);
		option.put(AUTOMATIC_METHOD_2_ID, AUTOMATIC_METHOD_2_TEXT);
		entry = new Tupel<String, Map<String, String>>(AUTOMATIC_METHOD_TEXT,
				option);
		options.put(AUTOMATIC_METHOD_ID, entry);

		entry = new Tupel<String, Map<String, String>>(RANDOM_CYCLES_TEXT, null);
		options.put(RANDOM_CYCLES_ID, entry);
		entry = new Tupel<String, Map<String, String>>(RANDOM_SEED_TEXT, null);
		options.put(RANDOM_SEED_ID, entry);

		// entry = new OptionsEntry(INTERPOLATION_THRESHOLD_TEXT, null);
		// options.put(INTERPOLATION_THRESHOLD_ID, entry);
		//
		// entry = new OptionsEntry(QUALITY_THRESHOLD_TEXT, null);
		// options.put(QUALITY_THRESHOLD_ID, entry);
		//
		// entry = new OptionsEntry(RECURSION_DEPTH_TEXT, null);
		// options.put(RECURSION_DEPTH_ID, entry);

		return options;
	}

	/**
	 * @param option
	 * @param value
	 * @return true if the value is in the correct format for the specified
	 *         option
	 */
	public static boolean checkOption(String option, String value) {

		if (option.equals(RANDOM_CYCLES_ID)) {
			try {
				Integer.parseInt(value);
				return true;
			} catch (NumberFormatException e) {
				return false;
			}
		}

		if (option.equals(RANDOM_SEED_ID)) {
			if (value != null && !value.equals("")) {
				return true;
			}
			return false;
		}

		// if (option.equals(INTERPOLATION_THRESHOLD_ID)) {
		// try {
		// Double.parseDouble(value);
		// return true;
		// } catch (NumberFormatException e) {
		// return false;
		// }
		// } else if (option.equals(QUALITY_THRESHOLD_ID)) {
		// try {
		// Double.parseDouble(value);
		// return true;
		// } catch (NumberFormatException e) {
		// return false;
		// }
		// } else if (option.equals(RECURSION_DEPTH_ID)) {
		// try {
		// Integer.parseInt(value);
		// return true;
		// } catch (NumberFormatException e) {
		// return false;
		// }
		// }
		return false;
	}

	public final static String HOSTSWITCH_ID = "HOSTSWITCH";
	public final static String HOSTSWITCH_TEXT = "Options for permitted host switchs.";
	public final static String HOSTSWITCH_0_ID = "0";
	public final static String HOSTSWITCH_0_TEXT = "all host switches are permitted (if the timezone fits)";
	public final static String HOSTSWITCH_1_ID = "1";
	public final static String HOSTSWITCH_1_TEXT = "host switches to ancestor nodes are not permitted [default]";
	public final static String HOSTSWITCH_2_ID = "2";
	public final static String HOSTSWITCH_2_TEXT = "no host switches are permitted";

	public final static String SORTING_ID = "SORTING";
	public final static String SORTING_TEXT = "Options for additional sorting costs during host switches.";
	public final static String SORTING_0_ID = "0";
	public final static String SORTING_0_TEXT = "direct host switch, no additional sorting costs for the host switch";
	public final static String SORTING_1_ID = "1";
	public final static String SORTING_1_TEXT = "host switch to a node in the same timezone and additional costs for sortings along the rest of the path [default]";
	public final static String SORTING_2_ID = "2";
	public final static String SORTING_2_TEXT = "costs for the host switch plus sorting costs for the whole path through the common ancestor";

	public final static String DUPLICATION_ID = "DUPLICATION";
	public final static String DUPLICATION_TEXT = "Options for additional duplication events during host switches.";
	public final static String DUPLICATION_0_ID = "0";
	public final static String DUPLICATION_0_TEXT = "host switches cause additional duplication events";
	public final static String DUPLICATION_1_ID = "1";
	public final static String DUPLICATION_1_TEXT = "host switches do not cause additional duplication events [default]";

	public final static String TAKEOFF_ID = "TAKEOFF";
	public final static String TAKEOFF_TEXT = "Options for the take-off site of host switches in case of timezone usage.";
	public final static String TAKEOFF_0_ID = "0";
	public final static String TAKEOFF_0_TEXT = "take-off happens immediately before the speciation [default]";
	public final static String TAKEOFF_1_ID = "1";
	public final static String TAKEOFF_1_TEXT = "take-off can also occur after the speciation when it is delayed by sortings";

	public final static String FULL_HOSTSWITCH_ID = "FULLHOSTSWITCH";
	public final static String FULL_HOSTSWITCH_TEXT = "Options for permitting full host switches (all children of a node perform a host switch).";
	public final static String FULL_HOSTSWITCH_0_ID = "0";
	public final static String FULL_HOSTSWITCH_0_TEXT = "full host switches are not permitted [default]";
	public final static String FULL_HOSTSWITCH_1_ID = "1";
	public final static String FULL_HOSTSWITCH_1_TEXT = "full host switches are permitted";

	public final static String RANK_ID = "RANK";
	public final static String RANK_TEXT = "Options for using timezone information.";
	public final static String RANK_0_ID = "0";
	public final static String RANK_0_TEXT = "timezones won't be used [default]";
	public final static String RANK_1_ID = "1";
	public final static String RANK_1_TEXT = "timezones will be used";

	public final static String PROBABILITY_COSTS_ID = "PROBABILITYCOSTS";
	public final static String PROBABILITY_COSTS_TEXT = "Options for the kind of cost value input.";
	public final static String PROBABILITY_COSTS_0_ID = "0";
	public final static String PROBABILITY_COSTS_0_TEXT = "absolute values [default]";
	public final static String PROBABILITY_COSTS_1_ID = "1";
	public final static String PROBABILITY_COSTS_1_TEXT = "probabilistic values (each value must be > 0 and < 1, the sum of all values mut be 1.";

	public final static String LEAF_SPECIACION_COST_ID = "LEAFSPECIACIONCOST";
	public final static String LEAF_SPECIACION_COST_TEXT = "Options for charging speciation costs in case parasite leafs are inserted due to multiple host associations.";
	public final static String LEAF_SPECIACION_COST_0_ID = "0";
	public final static String LEAF_SPECIACION_COST_0_TEXT = "costs of inserted speciations won't be charged [default]";
	public final static String LEAF_SPECIACION_COST_1_ID = "1";
	public final static String LEAF_SPECIACION_COST_1_TEXT = "costs of inserted speciations will be charged";

	public final static String ROOT_MAPPING_ID = "ROOTMAPPING";
	public final static String ROOT_MAPPING_TEXT = "Options for forcing a root-to-root mapping.";
	public final static String ROOT_MAPPING_0_ID = "0";
	public final static String ROOT_MAPPING_0_TEXT = "root-to-root mapping won't be forced [default]";
	public final static String ROOT_MAPPING_1_ID = "1";
	public final static String ROOT_MAPPING_1_TEXT = "root-to-root mapping will be forced";

	public final static String CHECK_CHRONOLOGY_ID = "CHECKCHRONOLOGY";
	public final static String CHECK_CHRONOLOGY_TEXT = "Options for checking chronological consistency.";
	public final static String CHECK_CHRONOLOGY_0_ID = "0";
	public final static String CHECK_CHRONOLOGY_0_TEXT = "chronological consistency won't be checked [default]";
	public final static String CHECK_CHRONOLOGY_1_ID = "1";
	public final static String CHECK_CHRONOLOGY_1_TEXT = "chronological consistency will be checked";

	public final static String AUTOMATIC_COSTS_ID = "AUTOMATICCOSTS";
	public final static String AUTOMATIC_COSTS_TEXT = "Options for calculating the cost values automatically.";
	public final static String AUTOMATIC_COSTS_0_ID = "0";
	public final static String AUTOMATIC_COSTS_0_TEXT = "given cost values will be used [default]";
	public final static String AUTOMATIC_COSTS_1_ID = "1";
	public final static String AUTOMATIC_COSTS_1_TEXT = "cost values will be calculated automatically";

	public final static String AUTOMATIC_METHOD_ID = "AUTOMATICMETHOD";
	public final static String AUTOMATIC_METHOD_TEXT = "Options for the used method of calculating the cost values automatically.";
	public final static String AUTOMATIC_METHOD_0_ID = "0";
	public final static String AUTOMATIC_METHOD_0_TEXT = "cost values will be choosen randomly";
	public final static String AUTOMATIC_METHOD_1_ID = "1";
	public final static String AUTOMATIC_METHOD_1_TEXT = "cost values will be calculated using the simplex method with random start values";
	public final static String AUTOMATIC_METHOD_2_ID = "2";
	public final static String AUTOMATIC_METHOD_2_TEXT = "cost values will be calculated using the simplex method on the quality function [default]";

	public final static String RANDOM_CYCLES_ID = "RANDOMCYCLES";
	public final static String RANDOM_CYCLES_TEXT = "a numeric value, specifying the amount of calculations which should be done with randon cost values [default: 5000]";
	public final static String RANDOM_SEED_ID = "RANDOMSEED";
	public final static String RANDOM_SEED_TEXT = "a numeric value, specifying the seed for initializing the random number generator (a non numeric value will use the system time) [default: auto]";

	// public final static String INTERPOLATION_THRESHOLD_ID =
	// "INTERPOLATIONTHRESHOLD";
	// public final static String INTERPOLATION_THRESHOLD_TEXT =
	// "a double value, specifying the threshold for the aberration of the linear interpolation [standard: 0.01]";
	// public final static String QUALITY_THRESHOLD_ID = "QUALITYTHRESHOLD";
	// public final static String QUALITY_THRESHOLD_TEXT =
	// "a double value, specifying the threshold for the minimal quality [standard: 0.25]";
	// public final static String RECURSION_DEPTH_ID = "RECURSIONDEPTH";
	// public final static String RECURSION_DEPTH_TEXT =
	// "an integer value, specifying the depht of the recursion [standard: 3]";

}
