/**
 * 
 */
package com.wieseke.cptk.input.dao;

import java.util.List;

import com.wieseke.cptk.common.api.IPositionHostNode;

/**
 * @author Nicolas Wieseke
 * 
 */
public class InputHostNode extends InputNode implements IPositionHostNode {

	/*
	 * (non-Javadoc)
	 * 
	 * @see com.wieseke.cptk.common.dao.PositionNode#getParent()
	 */
	
	public InputHostNode getParent() {
		return (InputHostNode) super.getParent();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see com.wieseke.cptk.input.dao.InputNode#getChildren()
	 */
	@SuppressWarnings("unchecked")
	
	public List<InputHostNode> getChildren() {
		return (List<InputHostNode>) super.getChildren();
	}

	/**
	 * the timezone of the host node
	 */
	private int rank;

	/**
	 * @return the rank
	 */
	
	public int getRank() {
		return this.rank;
	}

	/**
	 * @param rank
	 *            the rank to set
	 */
	
	public void setRank(int rank) {
		this.rank = rank;
	}

	public int getParentRank() {
		if (getParent() == null)
			return 0;
		else
			return getParent().getRank();
	}

	public int getChildRank() {
		if (isLeaf())
			return Integer.MAX_VALUE;
		else {
			int rank = Integer.MIN_VALUE;
			for (InputHostNode node : getChildren()) {
				rank = Math.max(rank, node.getRank());
			}
			return rank;
		}
	}

	
	public String getToolTipText() {
		return getLabel() + " (" + rank + ")";
	}

	
	public String getRankText() {
		return String.valueOf(rank);
	}

}
