/**
 * 
 */
package com.wieseke.cptk.input.wizards;

import org.eclipse.jface.wizard.Wizard;

import com.wieseke.cptk.input.dao.InputHostNode;

/**
 * @author Nicolas Wieseke
 * 
 */
public class ChangeHostRankWizard extends Wizard {

	private ChangeHostRankWizardPage changeHostRankWizardPage;
	private InputHostNode node;
	private int rank;

	public ChangeHostRankWizard(InputHostNode node) {
		this.node = node;
	}

	
	public boolean performFinish() {
		int value = changeHostRankWizardPage.getValue();
		if (value < 0) {
			this.changeHostRankWizardPage.setDescription("The timezone must be greater than 0.");
			return false;
		}
		int parentRank = node.getParentRank();
		if (parentRank > value) {
			this.changeHostRankWizardPage
					.setDescription("The timezone must be greater or equal than the timezone from the parent ["
							+ parentRank + "].");
			return false;
		}
		int childRank = node.getChildRank();
		if (!node.isLeaf() && childRank < value) {
			this.changeHostRankWizardPage
					.setDescription("The timezone must be lower or equal to the smallest timezone from the children ["
							+ childRank + "].");
			return false;
		}
		this.rank = value;
		return true;
	}

	
	public void addPages() {
		changeHostRankWizardPage = new ChangeHostRankWizardPage("Change label", ((InputHostNode) node).getRank());
		addPage(changeHostRankWizardPage);
		super.addPages();
	}

	/**
	 * @return the rank
	 */
	public int getRank() {
		return rank;
	}
}
