/**
 * 
 */
package com.wieseke.cptk.input.wizards;

import java.io.ByteArrayInputStream;
import java.io.InputStream;

import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.dialogs.WizardNewFileCreationPage;

import com.wieseke.cptk.common.exceptions.SerializeException;
import com.wieseke.cptk.input.dao.InputCophylogeny;
import com.wieseke.cptk.input.format.nexus.NexusSerializer;
import com.wieseke.cptk.statistics.TreeGenerator;

/**
 * @author Nicolas Wieseke
 * 
 */
public class RandomNexusFileWizardPage extends WizardNewFileCreationPage {

	private RandomNexusFileWizardPage2 page2;

	public RandomNexusFileWizardPage(IStructuredSelection selection,
			RandomNexusFileWizardPage2 page2) {
		super("WizardRandomNexusFileCreationPage", selection);
		this.page2 = page2;
		setTitle("Random Nexus File");
		setDescription("Creates a Random Nexus File ressource");
		setFileExtension("nex");
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * org.eclipse.ui.dialogs.WizardNewFileCreationPage#getInitialContents()
	 */

	protected InputStream getInitialContents() {
		InputCophylogeny cophylogeny = new TreeGenerator(page2.getRandom())
				.getRandomInputCophylogeny(getFileName(),
						page2.getHostLeaves(), page2.getParasiteLeaves(),
						page2.getModel(), page2.getAssociation());

		NexusSerializer serializer = new NexusSerializer();
		String str = "";
		try {
			str = serializer.serialize(cophylogeny, false);
		} catch (SerializeException e) {
		}
		return new ByteArrayInputStream(str.getBytes());
	}
}