/**
 * 
 */
package com.wieseke.cptk.output.provider;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import org.eclipse.jface.viewers.ITreeContentProvider;
import org.eclipse.jface.viewers.Viewer;

import com.wieseke.cptk.output.model.OutputReconstruction;
import com.wieseke.cptk.output.model.OutputReconstructionProperties;
import com.wieseke.cptk.output.model.OutputReconstructions;

/**
 * @author Nic
 * 
 */
public class ReconstructionContentProvider implements ITreeContentProvider,
		PropertyChangeListener {

	private final Viewer viewer;

	public ReconstructionContentProvider(Viewer viewer) {
		this.viewer = viewer;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * org.eclipse.jface.viewers.IStructuredContentProvider#getElements(java
	 * .lang.Object)
	 */
	
	public Object[] getElements(Object inputElement) {
		if (inputElement instanceof OutputReconstructions) {
			OutputReconstructions outputReconstructions = (OutputReconstructions) inputElement;
			return outputReconstructions.getChildren();
		}
		return null;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.viewers.IContentProvider#dispose()
	 */
	
	public void dispose() {

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * org.eclipse.jface.viewers.IContentProvider#inputChanged(org.eclipse.jface
	 * .viewers.Viewer, java.lang.Object, java.lang.Object)
	 */
	
	public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {

	}

	
	public void propertyChange(PropertyChangeEvent arg0) {
		this.viewer.refresh();
	}

	
	public Object[] getChildren(Object parentElement) {
		if (parentElement instanceof OutputReconstructions)
			return ((OutputReconstructions) parentElement).getChildren();
		if (parentElement instanceof OutputReconstruction)
			return ((OutputReconstruction) parentElement).getChildren();
		if (parentElement instanceof OutputReconstructionProperties)
			return ((OutputReconstructionProperties) parentElement)
					.getChildren();
		return null;
	}

	
	public Object getParent(Object element) {
		if (element instanceof OutputReconstructions)
			return ((OutputReconstructions) element).getParent();
		if (element instanceof OutputReconstruction)
			return ((OutputReconstruction) element).getParent();
		if (element instanceof OutputReconstructionProperties)
			return ((OutputReconstructionProperties) element).getParent();
		return null;
	}

	
	public boolean hasChildren(Object element) {
		if (element instanceof OutputReconstructions)
			return ((OutputReconstructions) element).hasChildren();
		if (element instanceof OutputReconstruction)
			return ((OutputReconstruction) element).hasChildren();
		if (element instanceof OutputReconstructionProperties)
			return ((OutputReconstructionProperties) element).hasChildren();
		return false;
	}

}
