/**
 * 
 */
package com.wieseke.cptk.reconstruction.constants;

/**
 * @author Nicolas Wieseke
 * 
 */
public class StatisticConstants {

	/**
	 * parameter for the yule tree generation model
	 */
	public final static String MODEL_MARKOV = "MARKOV";
	/**
	 * parameter for the beta-split random tree generation -1
	 */
	public final static String MODEL_ALDOUS = "ALDOUS";
	/**
	 * parameter for the beta-split random tree generation -1.5
	 */
	public final static String MODEL_PDA = "PDA";
	/**
	 * parameter for the age tree generation model
	 */
	public final static String MODEL_AGE = "AGE";

	/**
	 * parameter for computing no leaf associations
	 */
	public final static int ASSOCIATION_NONE = 0;
	/**
	 * parameter for computing random leaf associations, where every host leaf
	 * is used at most once
	 */
	public final static int ASSOCIATION_UNIQUE = 1;
	/**
	 * parameter for computing random leaf associations, where every host leaf
	 * can be used multiple times
	 */
	public final static int ASSOCIATION_MULTIPLE = 2;
}
